﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Net;


namespace EtherIO24SPI
{

    public partial class Form1 : Form
    {
          //These are used for listing Ether I/O 24's found on network
         string strIPAddress;
         string ReturnIPAddress;
         public string strHostName;
         //this is where the source port of the PC can be defined
         public UdpClient udpClient = new UdpClient(2424);
         public string addr = "10.10.10.10";
         public string strIPAddress1;
         public string broadcast = "255.255.255.255";
         public byte[] data = new byte[1024];
         public int DeviceNo;
         public int destport = 2424;
         public IPEndPoint EtherIP;
         public byte[] sendBytes;
         public uint PortValue,DirectionValue,PullupValue;
         List<IPEndPoint> IPList = new List<IPEndPoint>();
         public byte GPIO_ControlByte_U1 = 0x40;
         public byte GPIO_ControlByte_U2 = 0x40;
         public byte GPIO_ControlByte;
         public byte GPIO_RegisterByte;
         public byte GPIO_DataByte;
         public byte GPIO_ValueByte;
         public byte GPIO_DirectionByte;
         public byte GPIO_PullupByte;
         public byte SPI_data_length = 0x03;
         public byte LowerCS;
         public byte IdleCS;
         public bool Readflag;

         int list;
         int portA = 0;
        
        
         //the thread that will manage the data back from the board
         private System.Threading.Thread thdUDPServer;
         //this sub is to handle all the return data
         public delegate void ReturnUDPDataCallback(byte[] text, IPEndPoint IP);
         KeyPressEventArgs KeyPressBuffer = new KeyPressEventArgs((char)0);

        public Form1()
        {
            InitializeComponent();
            


        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Crank up UDP recieve Thread
            thdUDPServer = new System.Threading.Thread (new System.Threading.ThreadStart(serverThread));
            thdUDPServer.Start();

            //set up the variables
            
           
            Readflag = false;
            

            strHostName = System.Net.Dns.GetHostName();
            strIPAddress = System.Net.Dns.GetHostEntry(strHostName).AddressList[0].ToString();

        }
        public void serverThread()
        {
         while (true) 
         {
            
             System.Net.IPEndPoint RemoteIpEndPoint = new System.Net.IPEndPoint(System.Net.IPAddress.Any, 0);
             //with remoteIPenpoint the 0 in the above line can be changed to a specific port number
             //and it will only recieve data from that port number.
            
             byte[] receiveBytes;
            
             string returnData;

            

             receiveBytes = udpClient.Receive(ref RemoteIpEndPoint);
            
             returnData = System.Text.Encoding.ASCII.GetString(receiveBytes);
            
             if (returnData.Length != 0) 
              {
                 // test to see if there is anything to recieve
                  
                  if ((strIPAddress == RemoteIpEndPoint.Address.ToString()))
                  {
                     //filter any data sent by your PC
                 }
                 //Debug.Print(" Recieved from " + RemoteIpEndPoint.Address.ToString)
                 else {

                     if (ReturnIPAddress != RemoteIpEndPoint.Address.ToString())
                     {
                         // Setup list of Ether I/O IP address
                         IPList.Insert(list, RemoteIpEndPoint);
                         //Debug.Print(" IP added to list " + n.ToString + RemoteIpEndPoint.Address.ToString)
                         list = list + 1;
                     }
                     ReturnIPAddress = RemoteIpEndPoint.Address.ToString();
                    
                     //Return Data that was recieved from Ether I/O as well as IP address
                     ReturnUDPData(receiveBytes, RemoteIpEndPoint);
                     //Debug.Print(returnData)
                    
                 }
             }
            
         }
        
     }
          public void ReturnUDPData(byte[] UDPData, IPEndPoint RemoteIP)
     {
        
         string MacString;
         string VersionNumber;
         string UDPDataString;
         double VoltageADC;
      
        
         //*********************************
         //if we recieves 12 bytes back from the device then we have recived IO24 + MAC
         //**********************************
        
         if ((UDPData.Length == 12)) 
         {
            
             if (this.comboBox1.InvokeRequired) 
             {
                 ReturnUDPDataCallback d = new ReturnUDPDataCallback(ReturnUDPData);
                 this.comboBox1.Invoke(d, new object[] {UDPData, RemoteIP});
             }
             else 
             {
                 MacString = "  MAC:" + Convert.ToString(UDPData[4], 16) + ":";
                 MacString = MacString + Convert.ToString(UDPData[5], 16) + ":";
                 MacString = MacString + Convert.ToString(UDPData[6], 16) + ":";
                 MacString = MacString + Convert.ToString(UDPData[7], 16) + ":";
                 MacString = MacString + Convert.ToString(UDPData[8], 16) + ":";
                 MacString = MacString + Convert.ToString(UDPData[9], 16);


                 VersionNumber = Convert.ToString(UDPData[10], 16) + ".";
                 VersionNumber = VersionNumber + Convert.ToString(UDPData[11], 16);


                 MacString = MacString.ToUpper();
                 this.comboBox1.Items.Add(RemoteIP.Address.ToString() + MacString + "   V" + VersionNumber);
                 this.comboBox1.SelectedIndex = comboBox1.Items.Count - 1;
                 DeviceNo = comboBox1.SelectedIndex;
                 EtherIP = IPList[DeviceNo];
                
             }
            
         }

         if ((UDPData.Length == 6))  //SPI packets that we are recieving back are this long
         {
             //need to check for S first, then A, number of bytes, ignore two bytes and then data byte to read
             
                 if (UDPData[0] == 0x53) //we are dealing with an SPI packet coming back
                 {
                     if (this.PortDirHex.InvokeRequired)
                     {
                         ReturnUDPDataCallback d = new ReturnUDPDataCallback(ReturnUDPData);
                         this.PortDirHex.Invoke(d, new object[] { UDPData, RemoteIP });
                     }
                     else
                     {
                         portA = 0;
                         portA = UDPData[4];
                         portA = portA & (byte)0x07; // ADC[11]-ADC[8]
                         portA = (portA * 256) + UDPData[5]; // ADC[7]-ADC[0]
                         VoltageADC = (double)portA * 0.00488; // Conversion to Voltage from ADC // with VRef set to 5V
                         PortDirHex.AppendText("The voltage read from PD 1 is : " + VoltageADC + " V" + "\r\n");

                         //this.PortDirHex.Text = Convert.ToString(UDPData[5], 16);
                         ////read value
                         //GPIO_RegisterByte = GPIO_ValueByte;
                         //Lower_CS();
                         //Send_Read_GPIO();
                         //Readflag = true;
                         //Idle_CS();
                         //GPIO_RegisterByte = 0x00;

                     }  
                    

                 }
                 
             
         }


     }

          private void Ether_Scan_Click(object sender, EventArgs e)
          {
              sendBytes = Encoding.ASCII.GetBytes("IO24");

              udpClient.Send(sendBytes, sendBytes.Length, broadcast, destport);
          }

          private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
          {
                
   
                DeviceNo = comboBox1.SelectedIndex;
                EtherIP =  IPList[DeviceNo];

                
          }

          private void Enable_SPI_Click(object sender, EventArgs e)
          {

              //send out the enable command

              Send_Enable_SPI();
              
              ////Now to test the radio buttons to see which port needs to be read first

              //if (RB_U1_PORTA.Checked == true)
              //{
              //    Lower_CS_U1();
              //    Send_Read_PORTA_U1();
              //    Idle_CS_U1_U2();
              //}



          }
          

          private void Lower_CS()
          {
              data[0] = Convert.ToByte('A');//"A"
              data[1] = LowerCS; //"0x90" or "0x88

              udpClient.Send(data, 2, EtherIP);
          }

          private void Idle_CS()
          {
              data[0] = Convert.ToByte('A');//"A"
              data[1] = IdleCS; //"0x98"

              udpClient.Send(data, 2, EtherIP);
          }

        
          private void Send_Enable_SPI()
          {
              // Send out an SPI enable command
              //Need to set up the various CS and other pins associated with the board
              data[0] = Convert.ToByte('!'); //"!"
              data[1] = Convert.ToByte('A');//"A"
              data[2] = 0x04; //"0x48"

              udpClient.Send(data, 3, EtherIP);

              data[0] = Convert.ToByte('A');//"A"
              data[1] = 0x79; //"0x31" was 0x98

              udpClient.Send(data, 2, EtherIP);

              //Enable the SPI by sending S1A

              data[0] = Convert.ToByte('S'); //"S"
              data[1] = Convert.ToByte('1');//"1"
              data[2] = Convert.ToByte('A');//"A"

              udpClient.Send(data, 3, EtherIP);  //Send packet


          }
          private void Disable_SPI_Click(object sender, EventArgs e)
          {

              data[0] = Convert.ToByte('S'); //"S"
              data[1] = Convert.ToByte('0');//"1"
              data[2] = Convert.ToByte('A');//"A"

              udpClient.Send(data, 3, EtherIP);
          }

         
         private void GPIO_Port_Selection(object sender, EventArgs e)
          {
              //need to check which radio button is selected
              //and then set the appropriate values
              //Port direction, CS value, Port Value

              RadioButton radioBtn = (RadioButton) sender;
              string myRadioHandleChip;
              string myRadioHandlePort;

              if (radioBtn.Checked)

              {
                  myRadioHandleChip = radioBtn.Name.Substring(4, 1);  // this will tell what button was pressed 0 through to 7

                  myRadioHandlePort = radioBtn.Name.Substring(10, 1);

                  if (myRadioHandleChip == "1")
                  {
                      if (myRadioHandlePort == "A")
                      {
                          //set CS value
                          IdleCS = 0x99; //was 0x98 problem with reads so changed too
                          LowerCS = 0x91; //was 0x90
                          //sets the various registers for U1 port A
                          GPIO_ControlByte = GPIO_ControlByte_U1;
                          GPIO_ValueByte = 0x12;
                          GPIO_DirectionByte = 0x00;
                          GPIO_PullupByte = 0x0C;
                      }
                      if (myRadioHandlePort == "B")
                      {
                          //set CS value
                          IdleCS = 0x99;
                          LowerCS = 0x91;
                          //sets the various registers for U1 port B
                          GPIO_ControlByte = GPIO_ControlByte_U1;
                          GPIO_ValueByte = 0x13;
                          GPIO_DirectionByte = 0x01;
                          GPIO_PullupByte = 0x0D;
                      }
                  }
                  if (myRadioHandleChip == "2")
                  {
                      if (myRadioHandlePort == "A")
                      {
                          //set CS value
                          IdleCS = 0x99;
                          LowerCS = 0x89;

                          GPIO_ControlByte = GPIO_ControlByte_U2;
                          GPIO_ValueByte = 0x12;
                          GPIO_DirectionByte = 0x00;
                          GPIO_PullupByte = 0x0C;
                      }
                      if (myRadioHandlePort == "B")
                      {
                          //set CS value
                          IdleCS = 0x99;
                          LowerCS = 0x89;

                          GPIO_ControlByte = GPIO_ControlByte_U2;
                          GPIO_ValueByte = 0x13;
                          GPIO_DirectionByte = 0x01;
                          GPIO_PullupByte = 0x0D;
                      }
                   }

                  //MessageBox.Show("Radio Button: " + radioBtn.Text + " is checked");

              } // if (radioBtn.Checked)

          }

          private void button1_Click(object sender, EventArgs e)
          {
              //read direction
              GPIO_RegisterByte = GPIO_DirectionByte;
              Lower_CS();
              //Send_Read_GPIO();
              //Readflag = true;
              Idle_CS();

              ////read value
              //GPIO_RegisterByte = GPIO_ValueByte;
              //Lower_CS();
              //Send_Read_GPIO();
              //Readflag = true;
              //Idle_CS();

              ////read pullup
              //GPIO_RegisterByte = GPIO_PullupByte;
              //Lower_CS();
              //Send_Read_GPIO();
              //Readflag = true;
              //Idle_CS();

          }

          //*************************
          // Perform read on A/D CH 0
          //*************************
          private void button2_Click(object sender, EventArgs e)
          {
              //Lower CS pin for A/D
              data[0] = Convert.ToByte('A');//"A"
              data[1] = 0x71; //"0x98"
              udpClient.Send(data, 2, EtherIP);

              //Perform Read on A/D CH 0 will receive UDP packet back from SPI 
              //containing data from conversion. This will need to be dealt with in //data received thread

              data[0] = Convert.ToByte('S'); //"S"
              data[1] = Convert.ToByte('A'); //"A"
              data[2] = 0x03; //number of bytes to be sent out via SPI command
              data[3] = 0x01; //first byte  //start byte
              data[4] = 0x80; //second byte //command byte
              data[5] = 0x00; //third byte //null byte
              udpClient.Send(data, 6, EtherIP);

              //Raise CS to idle state
              data[0] = Convert.ToByte('A');//"A"
              data[1] = 0x79; //"0x98"
              udpClient.Send(data, 2, EtherIP);

          }
          //*************************
          // Set A/D channels to 2.5V
          //*************************
          private void button5_Click(object sender, EventArgs e)
          {
              //Lower CS pin for D/A
              data[0] = Convert.ToByte('A');//"A"
              data[1] = 0x38; //"0x98"
              udpClient.Send(data, 2, EtherIP);

              // VOUTB set to 2.5V

              data[0] = Convert.ToByte('S'); //"S"
              data[1] = Convert.ToByte('A'); //"A"
              data[2] = 0x02; //number of bytes to be sent out via SPI command
              data[3] = 0xF7; //first byte  //Write command register MSB
              data[4] = 0xFF; //second byte //Write command register LSB
              udpClient.Send(data, 5, EtherIP);

              //Raise CS to idle state
              data[0] = Convert.ToByte('A');//"A"
              data[1] = 0x78; //"0x98"
              udpClient.Send(data, 2, EtherIP);

              //Lower LDAC to output values
              data[0] = Convert.ToByte('A');//"A"
              data[1] = 0x68; //"0x98"
              udpClient.Send(data, 2, EtherIP);

              //Raise CS to idle state
              data[0] = Convert.ToByte('A');//"A"
              data[1] = 0x78; //"0x98"
              udpClient.Send(data, 2, EtherIP);

              //Lower CS pin for D/A
              data[0] = Convert.ToByte('A');//"A"
              data[1] = 0x38; //"0x98"
              udpClient.Send(data, 2, EtherIP);
               
              // VOUTA set to 2.5V

              data[0] = Convert.ToByte('S'); //"S"
              data[1] = Convert.ToByte('A'); //"A"
              data[2] = 0x02; //number of bytes to be sent out via SPI command
              data[3] = 0x77; //first byte  //Write command register MSB
              data[4] = 0xFF; //second byte //Write command register LSB
              udpClient.Send(data, 5, EtherIP);

              //Raise CS to idle state
              data[0] = Convert.ToByte('A');//"A"
              data[1] = 0x78; //"0x98"
              udpClient.Send(data, 2, EtherIP);

              //Lower LDAC to output values
              data[0] = Convert.ToByte('A');//"A"
              data[1] = 0x68; //"0x98"
              udpClient.Send(data, 2, EtherIP);

              //Raise CS to idle state
              data[0] = Convert.ToByte('A');//"A"
              data[1] = 0x78; //"0x98"
              udpClient.Send(data, 2, EtherIP);

             
          }

          private void button3_Click(object sender, EventArgs e)
          {
              data[0] = Convert.ToByte('A'); //"0x98"
              data[1] = 0xAA; //"0x90" or "0x88
              udpClient.Send(data, 2, EtherIP);
              data[0] = Convert.ToByte('A'); //"0x98"
              data[1] = 0x55; //"0x90" or "0x88
              udpClient.Send(data, 2, EtherIP);
              data[0] = Convert.ToByte('A'); //"0x98"
              data[1] = 0xaa; //"0x90" or "0x88
              udpClient.Send(data, 2, EtherIP);
              data[0] = Convert.ToByte('A'); //"0x98"
              data[1] = 0x55; //"0x90" or "0x88
              udpClient.Send(data, 2, EtherIP);
          }

          private void button4_Click(object sender, EventArgs e)
          {
              data[0] = Convert.ToByte('!'); //"0x98"
              data[1] = Convert.ToByte('A'); //"0x98"0xAA; //"0x90" or "0x88
              data[2] = 0x00; //"0x90" or "0x88
              udpClient.Send(data, 3, EtherIP);
          }

          private void PortDirHex_TextChanged(object sender, EventArgs e)
          {

          }

          private void PortDirHex_Leave(object sender, EventArgs e)
          {

          }

          private void PortDirHex_KeyPress(object sender, KeyPressEventArgs e)
          {

          }

          private void button6_Click(object sender, EventArgs e)
          {
              //******************************************************

              //Send Reset (does not work properly)

              //******************************************************



              data[0] = Convert.ToByte('S'); //"S"
              data[1] = Convert.ToByte('A');//"1"
              data[2] = 0x01;
              data[3] = 0x0C;
              //data[4] = 0x0C;


              udpClient.Send(data,4, EtherIP);  //Send packet

          }

          private void button7_Click(object sender, EventArgs e)
          {
              data[0] = Convert.ToByte('S'); //"S"
              data[1] = Convert.ToByte('A');//"1"
              data[2] = 0x02;
              data[3] = 0x0C;
              data[4] = 0x0C;


              udpClient.Send(data, 5, EtherIP);  //Send packet
          }

          private void button8_Click(object sender, EventArgs e)
          {
              data[0] = Convert.ToByte('S'); //"S"
              data[1] = Convert.ToByte('A');//"1"
              data[2] = 0x01;
              data[3] = 0x0C;
              data[4] = Convert.ToByte('a');//"1"


              udpClient.Send(data, 5, EtherIP);  //Send packet
          }

          

          

         

          

      

        

        

        
         

          
        
    }
}
